~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/scripts/faddr2line

Version: ~ [ linux-6.12-rc7 ] ~ [ linux-6.11.7 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.60 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.116 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.171 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.229 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.285 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.323 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.12 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /scripts/faddr2line (Version linux-6.12-rc7) and /scripts/faddr2line (Version linux-4.18.20)


  1 #!/bin/bash                                         1 #!/bin/bash
  2 # SPDX-License-Identifier: GPL-2.0                  2 # SPDX-License-Identifier: GPL-2.0
  3 #                                                   3 #
  4 # Translate stack dump function offsets.            4 # Translate stack dump function offsets.
  5 #                                                   5 #
  6 # addr2line doesn't work with KASLR addresses.      6 # addr2line doesn't work with KASLR addresses.  This works similarly to
  7 # addr2line, but instead takes the 'func+0x123      7 # addr2line, but instead takes the 'func+0x123' format as input:
  8 #                                                   8 #
  9 #   $ ./scripts/faddr2line ~/k/vmlinux meminfo      9 #   $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568
 10 #   meminfo_proc_show+0x5/0x568:                   10 #   meminfo_proc_show+0x5/0x568:
 11 #   meminfo_proc_show at fs/proc/meminfo.c:27      11 #   meminfo_proc_show at fs/proc/meminfo.c:27
 12 #                                                  12 #
 13 # If the address is part of an inlined functio     13 # If the address is part of an inlined function, the full inline call chain is
 14 # printed:                                         14 # printed:
 15 #                                                  15 #
 16 #   $ ./scripts/faddr2line ~/k/vmlinux native_     16 #   $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27
 17 #   native_write_msr+0x6/0x27:                     17 #   native_write_msr+0x6/0x27:
 18 #   arch_static_branch at arch/x86/include/asm     18 #   arch_static_branch at arch/x86/include/asm/msr.h:121
 19 #    (inlined by) static_key_false at include/     19 #    (inlined by) static_key_false at include/linux/jump_label.h:125
 20 #    (inlined by) native_write_msr at arch/x86     20 #    (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125
 21 #                                                  21 #
 22 # The function size after the '/' in the input     22 # The function size after the '/' in the input is optional, but recommended.
 23 # It's used to help disambiguate any duplicate     23 # It's used to help disambiguate any duplicate symbol names, which can occur
 24 # rarely.  If the size is omitted for a duplic     24 # rarely.  If the size is omitted for a duplicate symbol then it's possible for
 25 # multiple code sites to be printed:               25 # multiple code sites to be printed:
 26 #                                                  26 #
 27 #   $ ./scripts/faddr2line ~/k/vmlinux raw_ioc     27 #   $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5
 28 #   raw_ioctl+0x5/0x20:                            28 #   raw_ioctl+0x5/0x20:
 29 #   raw_ioctl at drivers/char/raw.c:122            29 #   raw_ioctl at drivers/char/raw.c:122
 30 #                                                  30 #
 31 #   raw_ioctl+0x5/0xb1:                            31 #   raw_ioctl+0x5/0xb1:
 32 #   raw_ioctl at net/ipv4/raw.c:876                32 #   raw_ioctl at net/ipv4/raw.c:876
 33 #                                                  33 #
 34 # Multiple addresses can be specified on a sin     34 # Multiple addresses can be specified on a single command line:
 35 #                                                  35 #
 36 #   $ ./scripts/faddr2line ~/k/vmlinux type_sh     36 #   $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90
 37 #   type_show+0x10/0x2d:                           37 #   type_show+0x10/0x2d:
 38 #   type_show at drivers/video/backlight/backl     38 #   type_show at drivers/video/backlight/backlight.c:213
 39 #                                                  39 #
 40 #   free_reserved_area+0x90/0x123:                 40 #   free_reserved_area+0x90/0x123:
 41 #   free_reserved_area at mm/page_alloc.c:6429     41 #   free_reserved_area at mm/page_alloc.c:6429 (discriminator 2)
 42                                                    42 
 43                                                    43 
 44 set -o errexit                                     44 set -o errexit
 45 set -o nounset                                     45 set -o nounset
 46                                                    46 
                                                   >>  47 READELF="${CROSS_COMPILE:-}readelf"
                                                   >>  48 ADDR2LINE="${CROSS_COMPILE:-}addr2line"
                                                   >>  49 SIZE="${CROSS_COMPILE:-}size"
                                                   >>  50 NM="${CROSS_COMPILE:-}nm"
                                                   >>  51 
                                                   >>  52 command -v awk >/dev/null 2>&1 || die "awk isn't installed"
                                                   >>  53 command -v ${READELF} >/dev/null 2>&1 || die "readelf isn't installed"
                                                   >>  54 command -v ${ADDR2LINE} >/dev/null 2>&1 || die "addr2line isn't installed"
                                                   >>  55 command -v ${SIZE} >/dev/null 2>&1 || die "size isn't installed"
                                                   >>  56 command -v ${NM} >/dev/null 2>&1 || die "nm isn't installed"
                                                   >>  57 
 47 usage() {                                          58 usage() {
 48         echo "usage: faddr2line [--list] <obje     59         echo "usage: faddr2line [--list] <object file> <func+offset> <func+offset>..." >&2
 49         exit 1                                     60         exit 1
 50 }                                                  61 }
 51                                                    62 
 52 warn() {                                           63 warn() {
 53         echo "$1" >&2                              64         echo "$1" >&2
 54 }                                                  65 }
 55                                                    66 
 56 die() {                                            67 die() {
 57         echo "ERROR: $1" >&2                       68         echo "ERROR: $1" >&2
 58         exit 1                                     69         exit 1
 59 }                                                  70 }
 60                                                    71 
 61 UTIL_SUFFIX=""                                 << 
 62 if [[ "${LLVM:-}" == "" ]]; then               << 
 63         UTIL_PREFIX=${CROSS_COMPILE:-}         << 
 64 else                                           << 
 65         UTIL_PREFIX=llvm-                      << 
 66                                                << 
 67         if [[ "${LLVM}" == *"/" ]]; then       << 
 68                 UTIL_PREFIX=${LLVM}${UTIL_PREF << 
 69         elif [[ "${LLVM}" == "-"* ]]; then     << 
 70                 UTIL_SUFFIX=${LLVM}            << 
 71         fi                                     << 
 72 fi                                             << 
 73                                                << 
 74 READELF="${UTIL_PREFIX}readelf${UTIL_SUFFIX}"  << 
 75 ADDR2LINE="${UTIL_PREFIX}addr2line${UTIL_SUFFI << 
 76 AWK="awk"                                      << 
 77 GREP="grep"                                    << 
 78                                                << 
 79 command -v ${AWK} >/dev/null 2>&1 || die "${AW << 
 80 command -v ${READELF} >/dev/null 2>&1 || die " << 
 81 command -v ${ADDR2LINE} >/dev/null 2>&1 || die << 
 82                                                << 
 83 # Try to figure out the source directory prefi     72 # Try to figure out the source directory prefix so we can remove it from the
 84 # addr2line output.  HACK ALERT: This assumes      73 # addr2line output.  HACK ALERT: This assumes that start_kernel() is in
 85 # init/main.c!  This only works for vmlinux.   !!  74 # kernel/init.c!  This only works for vmlinux.  Otherwise it falls back to
 86 # printing the absolute path.                      75 # printing the absolute path.
 87 find_dir_prefix() {                                76 find_dir_prefix() {
 88         local start_kernel_addr=$(echo "${ELF_ !!  77         local objfile=$1
 89                 ${AWK} '$8 == "start_kernel" { !!  78 
                                                   >>  79         local start_kernel_addr=$(${READELF} -sW $objfile | awk '$8 == "start_kernel" {printf "0x%s", $2}')
 90         [[ -z $start_kernel_addr ]] && return      80         [[ -z $start_kernel_addr ]] && return
 91                                                    81 
 92         run_addr2line ${start_kernel_addr} ""  !!  82         local file_line=$(${ADDR2LINE} -e $objfile $start_kernel_addr)
 93         [[ -z $ADDR2LINE_OUT ]] && return      !!  83         [[ -z $file_line ]] && return
 94                                                    84 
 95         local file_line=${ADDR2LINE_OUT#* at } << 
 96         if [[ -z $file_line ]] || [[ $file_lin << 
 97                 return                         << 
 98         fi                                     << 
 99         local prefix=${file_line%init/main.c:*     85         local prefix=${file_line%init/main.c:*}
100         if [[ -z $prefix ]] || [[ $prefix = $f     86         if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then
101                 return                             87                 return
102         fi                                         88         fi
103                                                    89 
104         DIR_PREFIX=$prefix                         90         DIR_PREFIX=$prefix
105         return 0                                   91         return 0
106 }                                                  92 }
107                                                    93 
108 run_readelf() {                                << 
109         local objfile=$1                       << 
110         local out=$(${READELF} --file-header - << 
111                                                << 
112         # This assumes that readelf first prin << 
113         # Note: It seems that GNU readelf does << 
114         # line when multiple options are given << 
115         ELF_FILEHEADER=$(echo "${out}" | sed - << 
116         ELF_SECHEADERS=$(echo "${out}" | sed - << 
117         ELF_SYMS=$(echo "${out}" | sed -n '/Sy << 
118 }                                              << 
119                                                << 
120 check_vmlinux() {                              << 
121         # vmlinux uses absolute addresses in t << 
122         # section offsets.                     << 
123         IS_VMLINUX=0                           << 
124         local file_type=$(echo "${ELF_FILEHEAD << 
125                 ${AWK} '$1 == "Type:" { print  << 
126         if [[ $file_type = "EXEC" ]] || [[ $fi << 
127                 IS_VMLINUX=1                   << 
128         fi                                     << 
129 }                                              << 
130                                                << 
131 init_addr2line() {                             << 
132         local objfile=$1                       << 
133                                                << 
134         check_vmlinux                          << 
135                                                << 
136         ADDR2LINE_ARGS="--functions --pretty-p << 
137         if [[ $IS_VMLINUX = 1 ]]; then         << 
138                 # If the executable file is vm << 
139                 # addr2line, so we can launch  << 
140                 coproc ADDR2LINE_PROC (${ADDR2 << 
141         fi                                     << 
142 }                                              << 
143                                                << 
144 run_addr2line() {                              << 
145         local addr=$1                          << 
146         local sec_name=$2                      << 
147                                                << 
148         if [[ $IS_VMLINUX = 1 ]]; then         << 
149                 # We send to the addr2line pro << 
150                 # value, i.e., something that  << 
151                 # (i.e., ","). This causes add << 
152                 # our address, then (2) either << 
153                 # using binutils' addr2line),  << 
154                 echo ${addr} >& "${ADDR2LINE_P << 
155                 echo "," >& "${ADDR2LINE_PROC[ << 
156                 local first_line               << 
157                 read -r first_line <& "${ADDR2 << 
158                 ADDR2LINE_OUT=$(echo "${first_ << 
159                 while read -r line <& "${ADDR2 << 
160                         if [[ "$line" == "?? ? << 
161                                 break          << 
162                         fi                     << 
163                         ADDR2LINE_OUT+=$'\n'$( << 
164                 done                           << 
165         else                                   << 
166                 # Run addr2line as a single in << 
167                 local sec_arg                  << 
168                 [[ -z $sec_name ]] && sec_arg= << 
169                 ADDR2LINE_OUT=$(${ADDR2LINE} $ << 
170         fi                                     << 
171 }                                              << 
172                                                << 
173 __faddr2line() {                                   94 __faddr2line() {
174         local objfile=$1                           95         local objfile=$1
175         local func_addr=$2                         96         local func_addr=$2
176         local dir_prefix=$3                        97         local dir_prefix=$3
177         local print_warnings=$4                    98         local print_warnings=$4
178                                                    99 
179         local sym_name=${func_addr%+*}         !! 100         local func=${func_addr%+*}
180         local func_offset=${func_addr#*+}      !! 101         local offset=${func_addr#*+}
181         func_offset=${func_offset%/*}          !! 102         offset=${offset%/*}
182         local user_size=                       !! 103         local size=
183         [[ $func_addr =~ "/" ]] && user_size=$ !! 104         [[ $func_addr =~ "/" ]] && size=${func_addr#*/}
184                                                   105 
185         if [[ -z $sym_name ]] || [[ -z $func_o !! 106         if [[ -z $func ]] || [[ -z $offset ]] || [[ $func = $func_addr ]]; then
186                 warn "bad func+offset $func_ad    107                 warn "bad func+offset $func_addr"
187                 DONE=1                            108                 DONE=1
188                 return                            109                 return
189         fi                                        110         fi
190                                                   111 
191         # Go through each of the object's symb    112         # Go through each of the object's symbols which match the func name.
192         # In rare cases there might be duplica !! 113         # In rare cases there might be duplicates.
193         # matches.                             !! 114         file_end=$(${SIZE} -Ax $objfile | awk '$1 == ".text" {print $2}')
194         while read line; do                    !! 115         while read symbol; do
195                 local fields=($line)           !! 116                 local fields=($symbol)
196                 local sym_addr=0x${fields[1]}  !! 117                 local sym_base=0x${fields[0]}
197                 local sym_elf_size=${fields[2] !! 118                 local sym_type=${fields[1]}
198                 local sym_sec=${fields[6]}     !! 119                 local sym_end=${fields[3]}
199                 local sec_size                 << 
200                 local sec_name                 << 
201                                                << 
202                 # Get the section size:        << 
203                 sec_size=$(echo "${ELF_SECHEAD << 
204                         ${AWK} -v sec=$sym_sec << 
205                                                << 
206                 if [[ -z $sec_size ]]; then    << 
207                         warn "bad section size << 
208                         DONE=1                 << 
209                         return                 << 
210                 fi                             << 
211                                                << 
212                 # Get the section name:        << 
213                 sec_name=$(echo "${ELF_SECHEAD << 
214                         ${AWK} -v sec=$sym_sec << 
215                                                << 
216                 if [[ -z $sec_name ]]; then    << 
217                         warn "bad section name << 
218                         DONE=1                 << 
219                         return                 << 
220                 fi                             << 
221                                                << 
222                 # Calculate the symbol size.   << 
223                 #                              << 
224                 # Unfortunately we can't use t << 
225                 # also includes the padding by << 
226                 # kallsyms, the size calculati << 
227                 # symbol and the next symbol i << 
228                 local sym_size                 << 
229                 local cur_sym_addr             << 
230                 local found=0                  << 
231                 while read line; do            << 
232                         local fields=($line)   << 
233                         cur_sym_addr=0x${field << 
234                         local cur_sym_elf_size << 
235                         local cur_sym_name=${f << 
236                                                << 
237                         # is_mapping_symbol(cu << 
238                         if [[ ${cur_sym_name}  << 
239                                 continue       << 
240                         fi                     << 
241                                                << 
242                         if [[ $cur_sym_addr =  << 
243                            [[ $cur_sym_elf_siz << 
244                            [[ $cur_sym_name =  << 
245                                 found=1        << 
246                                 continue       << 
247                         fi                     << 
248                                                << 
249                         if [[ $found = 1 ]]; t << 
250                                 sym_size=$(($c << 
251                                 [[ $sym_size - << 
252                                 found=2        << 
253                                 break          << 
254                         fi                     << 
255                 done < <(echo "${ELF_SYMS}" |  << 
256                                                << 
257                 if [[ $found = 0 ]]; then      << 
258                         warn "can't find symbo << 
259                         DONE=1                 << 
260                         return                 << 
261                 fi                             << 
262                                                << 
263                 # If nothing was found after t << 
264                 # symbol in the section.       << 
265                 [[ $found = 1 ]] && sym_size=$ << 
266                                                   120 
                                                   >> 121                 # calculate the size
                                                   >> 122                 local sym_size=$(($sym_end - $sym_base))
267                 if [[ -z $sym_size ]] || [[ $s    123                 if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then
268                         warn "bad symbol size: !! 124                         warn "bad symbol size: base: $sym_base end: $sym_end"
269                         DONE=1                    125                         DONE=1
270                         return                    126                         return
271                 fi                                127                 fi
272                                                << 
273                 sym_size=0x$(printf %x $sym_si    128                 sym_size=0x$(printf %x $sym_size)
274                                                   129 
275                 # Calculate the address from u !! 130                 # calculate the address
276                 local addr=$(($sym_addr + $fun !! 131                 local addr=$(($sym_base + $offset))
277                 if [[ -z $addr ]] || [[ $addr     132                 if [[ -z $addr ]] || [[ $addr = 0 ]]; then
278                         warn "bad address: $sy !! 133                         warn "bad address: $sym_base + $offset"
279                         DONE=1                    134                         DONE=1
280                         return                    135                         return
281                 fi                                136                 fi
282                 addr=0x$(printf %x $addr)         137                 addr=0x$(printf %x $addr)
283                                                   138 
284                 # If the user provided a size, !! 139                 # weed out non-function symbols
285                 if [[ -n $user_size ]] && [[ $ !! 140                 if [[ $sym_type != t ]] && [[ $sym_type != T ]]; then
                                                   >> 141                         [[ $print_warnings = 1 ]] &&
                                                   >> 142                                 echo "skipping $func address at $addr due to non-function symbol of type '$sym_type'"
                                                   >> 143                         continue
                                                   >> 144                 fi
                                                   >> 145 
                                                   >> 146                 # if the user provided a size, make sure it matches the symbol's size
                                                   >> 147                 if [[ -n $size ]] && [[ $size -ne $sym_size ]]; then
286                         [[ $print_warnings = 1    148                         [[ $print_warnings = 1 ]] &&
287                                 echo "skipping !! 149                                 echo "skipping $func address at $addr due to size mismatch ($size != $sym_size)"
288                         continue;                 150                         continue;
289                 fi                                151                 fi
290                                                   152 
291                 # Make sure the provided offse !! 153                 # make sure the provided offset is within the symbol's range
292                 if [[ $func_offset -gt $sym_si !! 154                 if [[ $offset -gt $sym_size ]]; then
293                         [[ $print_warnings = 1    155                         [[ $print_warnings = 1 ]] &&
294                                 echo "skipping !! 156                                 echo "skipping $func address at $addr due to size mismatch ($offset > $sym_size)"
295                         continue                  157                         continue
296                 fi                                158                 fi
297                                                   159 
298                 # In case of duplicates or mul !! 160                 # separate multiple entries with a blank line
299                 # cmdline, separate multiple e << 
300                 [[ $FIRST = 0 ]] && echo          161                 [[ $FIRST = 0 ]] && echo
301                 FIRST=0                           162                 FIRST=0
302                                                   163 
303                 echo "$sym_name+$func_offset/$ !! 164                 # pass real address to addr2line
                                                   >> 165                 echo "$func+$offset/$sym_size:"
                                                   >> 166                 local file_lines=$(${ADDR2LINE} -fpie $objfile $addr | sed "s; $dir_prefix\(\./\)*; ;")
                                                   >> 167                 [[ -z $file_lines ]] && return
304                                                   168 
305                 # Pass section address to addr << 
306                 # from the output:             << 
307                 run_addr2line $addr $sec_name  << 
308                 local output=$(echo "${ADDR2LI << 
309                 [[ -z $output ]] && continue   << 
310                                                << 
311                 # Default output (non --list): << 
312                 if [[ $LIST = 0 ]]; then          169                 if [[ $LIST = 0 ]]; then
313                         echo "$output" | while !! 170                         echo "$file_lines" | while read -r line
314                         do                        171                         do
315                                 echo $line        172                                 echo $line
316                         done                      173                         done
317                         DONE=1;                   174                         DONE=1;
318                         continue               !! 175                         return
319                 fi                                176                 fi
320                                                   177 
321                 # For --list, show each line w !! 178                 # show each line with context
322                 echo "$output" | while read -r !! 179                 echo "$file_lines" | while read -r line
323                 do                                180                 do
324                         echo                      181                         echo
325                         echo $line                182                         echo $line
326                         n=$(echo $line | sed '    183                         n=$(echo $line | sed 's/.*:\([0-9]\+\).*/\1/g')
327                         n1=$[$n-5]                184                         n1=$[$n-5]
328                         n2=$[$n+5]                185                         n2=$[$n+5]
329                         f=$(echo $line | sed '    186                         f=$(echo $line | sed 's/.*at \(.\+\):.*/\1/g')
330                         ${AWK} 'NR>=strtonum(" !! 187                         awk 'NR>=strtonum("'$n1'") && NR<=strtonum("'$n2'") { if (NR=='$n') printf(">%d<", NR); else printf(" %d ", NR); printf("\t%s\n", $0)}' $f
331                 done                              188                 done
332                                                   189 
333                 DONE=1                            190                 DONE=1
334                                                   191 
335         done < <(echo "${ELF_SYMS}" | sed 's/\ !! 192         done < <(${NM} -n $objfile | awk -v fn=$func -v end=$file_end '$3 == fn { found=1; line=$0; start=$1; next } found == 1 { found=0; print line, "0x"$1 } END {if (found == 1) print line, end; }')
336 }                                                 193 }
337                                                   194 
338 [[ $# -lt 2 ]] && usage                           195 [[ $# -lt 2 ]] && usage
339                                                   196 
340 objfile=$1                                        197 objfile=$1
341                                                   198 
342 LIST=0                                            199 LIST=0
343 [[ "$objfile" == "--list" ]] && LIST=1 && shif    200 [[ "$objfile" == "--list" ]] && LIST=1 && shift && objfile=$1
344                                                   201 
345 [[ ! -f $objfile ]] && die "can't find objfile    202 [[ ! -f $objfile ]] && die "can't find objfile $objfile"
346 shift                                             203 shift
347                                                   204 
348 run_readelf $objfile                           << 
349                                                << 
350 echo "${ELF_SECHEADERS}" | ${GREP} -q '\.debug << 
351                                                << 
352 init_addr2line $objfile                        << 
353                                                << 
354 DIR_PREFIX=supercalifragilisticexpialidocious     205 DIR_PREFIX=supercalifragilisticexpialidocious
355 find_dir_prefix                                !! 206 find_dir_prefix $objfile
356                                                   207 
357 FIRST=1                                           208 FIRST=1
358 while [[ $# -gt 0 ]]; do                          209 while [[ $# -gt 0 ]]; do
359         func_addr=$1                              210         func_addr=$1
360         shift                                     211         shift
361                                                   212 
362         # print any matches found                 213         # print any matches found
363         DONE=0                                    214         DONE=0
364         __faddr2line $objfile $func_addr $DIR_    215         __faddr2line $objfile $func_addr $DIR_PREFIX 0
365                                                   216 
366         # if no match was found, print warning    217         # if no match was found, print warnings
367         if [[ $DONE = 0 ]]; then                  218         if [[ $DONE = 0 ]]; then
368                 __faddr2line $objfile $func_ad    219                 __faddr2line $objfile $func_addr $DIR_PREFIX 1
369                 warn "no match for $func_addr"    220                 warn "no match for $func_addr"
370         fi                                        221         fi
371 done                                              222 done
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php